<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseStarDay ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseStarDay extends AbstractStructArrayBase
{
    /**
     * The StarDay
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseStarDay[]
     */
    public $StarDay;
    /**
     * Constructor method for ArrayOfJP_CruiseStarDay
     * @uses ArrayOfJP_CruiseStarDay::setStarDay()
     * @param \StructType\JP_CruiseStarDay[] $starDay
     */
    public function __construct(array $starDay = array())
    {
        $this
            ->setStarDay($starDay);
    }
    /**
     * Get StarDay value
     * @return \StructType\JP_CruiseStarDay[]|null
     */
    public function getStarDay()
    {
        return $this->StarDay;
    }
    /**
     * Set StarDay value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseStarDay[] $starDay
     * @return \ArrayType\ArrayOfJP_CruiseStarDay
     */
    public function setStarDay(array $starDay = array())
    {
        foreach ($starDay as $arrayOfJP_CruiseStarDayStarDayItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseStarDayStarDayItem instanceof \StructType\JP_CruiseStarDay) {
                throw new \InvalidArgumentException(sprintf('The StarDay property can only contain items of \StructType\JP_CruiseStarDay, "%s" given', is_object($arrayOfJP_CruiseStarDayStarDayItem) ? get_class($arrayOfJP_CruiseStarDayStarDayItem) : gettype($arrayOfJP_CruiseStarDayStarDayItem)), __LINE__);
            }
        }
        $this->StarDay = $starDay;
        return $this;
    }
    /**
     * Add item to StarDay value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseStarDay $item
     * @return \ArrayType\ArrayOfJP_CruiseStarDay
     */
    public function addToStarDay(\StructType\JP_CruiseStarDay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseStarDay) {
            throw new \InvalidArgumentException(sprintf('The StarDay property can only contain items of \StructType\JP_CruiseStarDay, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StarDay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StarDay
     */
    public function getAttributeName()
    {
        return 'StarDay';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_CruiseStarDay
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
